// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.15.0
// source: emails.sql

package database

import (
	"context"
	"database/sql"
	"time"
)

const emailAnonymize = `-- name: EmailAnonymize :exec
UPDATE emails
SET header_to = 'anonymous@anonymous.invalid', text_plain = ''
WHERE booking_id = ?
`

func (q *Queries) EmailAnonymize(ctx context.Context, bookingID int32) error {
	_, err := q.db.ExecContext(ctx, emailAnonymize, bookingID)
	return err
}

const emailCreate = `-- name: EmailCreate :one
INSERT INTO emails (id, booking_id, header_from, header_to, header_subject, text_plain, fatal_error)
VALUES (?, ?, ?, ?, ?, ?, ?)
RETURNING id, booking_id, header_from, header_to, header_subject, text_plain, created_at, sent_at, fatal_error
`

type EmailCreateParams struct {
	ID            string
	BookingID     int32
	HeaderFrom    string
	HeaderTo      string
	HeaderSubject string
	TextPlain     string
	FatalError    string
}

func (q *Queries) EmailCreate(ctx context.Context, arg EmailCreateParams) (Email, error) {
	row := q.db.QueryRowContext(ctx, emailCreate,
		arg.ID,
		arg.BookingID,
		arg.HeaderFrom,
		arg.HeaderTo,
		arg.HeaderSubject,
		arg.TextPlain,
		arg.FatalError,
	)
	var i Email
	err := row.Scan(
		&i.ID,
		&i.BookingID,
		&i.HeaderFrom,
		&i.HeaderTo,
		&i.HeaderSubject,
		&i.TextPlain,
		&i.CreatedAt,
		&i.SentAt,
		&i.FatalError,
	)
	return i, err
}

const emailForBooking = `-- name: EmailForBooking :many
SELECT id, booking_id, header_from, header_to, header_subject, text_plain, created_at, sent_at, fatal_error
FROM emails
WHERE booking_id = ?
ORDER BY created_at DESC, id DESC
`

func (q *Queries) EmailForBooking(ctx context.Context, bookingID int32) ([]Email, error) {
	rows, err := q.db.QueryContext(ctx, emailForBooking, bookingID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Email
	for rows.Next() {
		var i Email
		if err := rows.Scan(
			&i.ID,
			&i.BookingID,
			&i.HeaderFrom,
			&i.HeaderTo,
			&i.HeaderSubject,
			&i.TextPlain,
			&i.CreatedAt,
			&i.SentAt,
			&i.FatalError,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const emailPending = `-- name: EmailPending :many
SELECT id, booking_id, header_from, header_to, header_subject, text_plain, created_at, sent_at, fatal_error
FROM emails
WHERE sent_at IS NULL AND fatal_error = '' AND created_at > ?
`

func (q *Queries) EmailPending(ctx context.Context, createdAt time.Time) ([]Email, error) {
	rows, err := q.db.QueryContext(ctx, emailPending, createdAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Email
	for rows.Next() {
		var i Email
		if err := rows.Scan(
			&i.ID,
			&i.BookingID,
			&i.HeaderFrom,
			&i.HeaderTo,
			&i.HeaderSubject,
			&i.TextPlain,
			&i.CreatedAt,
			&i.SentAt,
			&i.FatalError,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const emailUpdate = `-- name: EmailUpdate :exec
UPDATE emails
SET sent_at = ?, fatal_error = ?
WHERE id = ?
`

type EmailUpdateParams struct {
	SentAt     sql.NullTime
	FatalError string
	ID         string
}

func (q *Queries) EmailUpdate(ctx context.Context, arg EmailUpdateParams) error {
	_, err := q.db.ExecContext(ctx, emailUpdate, arg.SentAt, arg.FatalError, arg.ID)
	return err
}
